////////////////////////////////////////////////////////////////////////////
//# Author Aviral Mittal
//# ISLI 2005/2006
//# File Name mes.v
////////////////////////////////////////////////////////////////////////////
`timescale 1ns/1ps

module fifo_lp(
            datout,
            full,
            empty,
            clk,
            wr,
            rd,
            rst_n,
            datin
            );
`ifdef CIF  //SIMONLY
`include "../rtl/cif_parameters.v" //SIMONLY
`else //SIMONLY
`include "../rtl/qcif_parameters.v"
`endif //SIMONLY


  parameter DMsb = data_width-1;
  parameter depth = broww * bcoll;

  output [DMsb:0] datout;
  output full;
  output empty;
  input  clk;
  input  wr;
  input  rd;
  input  rst_n;
  input  [DMsb:0] datin;

  reg [DMsb:0] datout;
  reg [DMsb:0] mem[depth-1:0];
 
  reg [logNumBlocks:0] rd_addr;
  reg [logNumBlocks:0] wr_addr;

  //reg full;
  wire n_full;

  always @ (posedge clk)
  begin
    if(rst_n == 0)
    begin
      rd_addr<=0;
      wr_addr<=0;
    end
    else
    begin
    //if(wr && n_full==0)
    if(wr)
      if(wr_addr == depth - 1)
        wr_addr <= 0;
      else
        wr_addr <= wr_addr+1;
    //if(rd && empty==0)
    if(rd)
      if(rd_addr == depth-1)
        rd_addr <= 0;
      else
        rd_addr <= rd_addr+1;
    end
  end

  always @ (posedge clk)
  begin
    if(wr)
      mem[wr_addr] <= datin;
    if(rd)
      datout <= mem[rd_addr];
  end

  assign empty = (wr_addr==rd_addr) ? 1 : 0;
  assign n_full = ((wr_addr-rd_addr)==depth-1) ? 1 : 0;
//  always @ (posedge clk)
//  begin
//    if(rst_n == 0)
//      full <= 0;
//    else 
//      full <= n_full;
//  end
  
  assign full = n_full;

  //pragma synthesis_off
    //always @ (rd,wr,rd_addr,wr_addr,full,empty)
    always @ (posedge clk)
    begin
      //if(full && wr) $display("WARNING! fifo_lp: Attempt to write a full fifo %d at time ",$time);
      //if(empty && rd) $display("WARNING! fifo_lp: Attempt to read from a empty fifo %d at time ",$time);
    end
  //pragma synthesis_on

endmodule
