//########################################################
//# Test Bench Generated by vlogtb.pl 
//# Author : Aviral Mittal
//########################################################
 `timescale 1ns/1ps
`define INIT_DELAY 20 //clock period

module mes_tb ;
  parameter roww      = 144;
  parameter l2roww    = 9;
  parameter coll      = 176;
  parameter l2coll    = 9;
  parameter broww     = 4;
  parameter l2broww   = 6;
  parameter bcoll     = 4;
  parameter l2bcoll   = 6;
  parameter rscopee   = 8;
  parameter l2rscopee = 6;
  parameter cscopee   = 8;
  parameter l2cscopee = 6;
  parameter rrwidth   = 7;
  parameter ccwidth   = 7;

   parameter words = 131072;
   parameter addMsb = 16;
   parameter bitMsb = 31;


  reg start;
  reg clk;
  reg reset;
  wire [7:0] Dref;
  wire [7:0] Dcur;
  wire [7:0] mv_x;
  wire [7:0] mv_y;
  wire [15:0] min_sad;
  wire [9:0] partition_mode;
  wire mfinish;
  wire [16:0] ADRRef;
  wire CENRef;
  wire WENRef;
  wire OENRef;
  wire [16:0] ADRCur;
  wire CENCur;
  wire WENCur;
  wire OENCur;
  wire [16:0] ADRRec;
  wire CENRec;
  wire WENRec;
  wire OENRec;
  wire [7:0] DRec;

  reg initing;

  reg [16:0] counter_tb;
  reg CENRefTb;
  reg WENRefTb;
  reg OENRefTb;
  reg [16:0] ADRCurTb;
 
  reg CK;
  reg CEN;
  reg WEN;
  reg OEN;
  reg [addMsb:0] ADR;
  reg [bitMsb:0] DI;
  wire [bitMsb:0] DOUTRef;
  wire [bitMsb:0] DOUTCur;

  reg [30:0] ii;
  reg reset_tb;
mes mes (
.start(start),
.clk(clk),
.reset(reset),
.Dref(DOUTRef),
.Dcur(DOUTCur),
.mv_x(mv_x),
.mv_y(mv_y),
.min_sad(min_sad),
.partition_mode(partition_mode),
.mfinish(mfinish),
.ADRRef(ADRRef),
.CENRef(CENRef),
.WENRef(WENRef),
.OENRef(OENRef),
.ADRCur(ADRCur),
.CENCur(CENCur),
.WENCur(WENCur),
.OENCur(OENCur),
.ADRRec(ADRRec),
.CENRec(CENRec),
.WENRec(WENRec),
.OENRec(OENRec),
.DRec(DRec)
);
  initial
  begin
    clk = 1 ;
    reset = 0 ;
    start = 0;
    ii = 0;
    reset_tb=0;
    initing =0;
    #44 initing = 1;
    #244 reset_tb = 1;
    #44 reset = 1;
    //#7000000000 $finish;
  end
  always #5 clk <= ~clk ;

  always @ (posedge clk)
    if(reset_tb==0)
      counter_tb <= 0;
    else
      counter_tb <= counter_tb + 1;

//  always @ (posedge clk)
//  begin
//    $display("ADRRef = %d  ADRCur = %d     time=%d", ADRRef,ADRCur,$time);
//    ii<=ii+1;
//    //$writememb("./mem_file1.v",ADRRef);
//    //$writememb("./mem_file1.v",ADRCur);
//  end


  always @ (posedge clk)
    if(counter_tb == `INIT_DELAY)
      start <= 1;
    else if(mfinish)
      start <= 0;


R64X32M4_Ref R64X32M4_Ref (
.CK(clk),
.CEN(CENRef),
.WEN(WENRef),
.OEN(OENRef),
.ADR(ADRRef),
.DI(DIRef),
.DOUT(DOUTRef)
);

R64X32M4_Cur R64X32M4_Cur (
.CK(clk),
.CEN(CENCur),
.WEN(WENCur),
.OEN(OENCur),
.ADR(ADRCur),
.DI(DICur),
.DOUT(DOUTCur)
);

R64X32M4_Rec R64X32M4_Rec (
.CK(clk),
.CEN(CENRec),
.WEN(WENRec),
.OEN(OENRec),
.ADR(ADRRec),
.DI(DRec),
.DOUT(DOUTRec)
);
endmodule
