// 
// Copyright (C) 2003 Virtual Silicon Technology Inc. All Rights Reserved.
// Silicon Ready, The Heart of Great Silicon, and the Virtual Silicon logo are
// registered trademarks of Virtual Silicon Technology Inc. All other trademarks
// are the property of their respective owner.
// 
// Virtual Silicon Technology Inc.
// 1200 Crossman Ave
// Sunnyvale, CA 94089-1116
// Phone : 408-548-2700
// Fax : 408-548-2750
// Web Site : www.virtual-silicon.com
// 
// VST Library Release: UMCE13H410T3_1.0
// Product: Single Port SRAM Compiler
// Process: L130E HS-FSG
// 
// One-Port RAM 64 words by 32 bits
// column mux = 4
// bytewrite  = n
// test       = n
// powerbus   = a
// frequency  = 100
// 
`timescale 1 ns / 1 ps
`celldefine

module R64X32M4_Cur (
  CK,
  CEN,
  WEN,
  OEN,
  ADR,
  DI,
  DOUT
  );

  parameter words = 25344;
  parameter addMsb = 16;
  parameter bitMsb = 31;

  input CK;
  input CEN;
  input WEN;
  input OEN;
  input [addMsb:0] ADR;
  input [bitMsb:0] DI;
  output [bitMsb:0] DOUT;
  reg [bitMsb:0] DOUT;

  reg[bitMsb:0] mem [0:words];

  reg [addMsb:0] ii;

initial
begin
  $readmemb("mem.cur", mem, 0, words);  //read from addres 0 to 15
  //for (ii= 0; ii<words; ii=ii+1) $display("mem[%0d] %d", ii, mem[ii]);
end

  always @ (posedge CK)
  begin
    if(CEN==0 && WEN == 0)
      mem[ADR] <= DI;
    if(CEN==0 && WEN == 1 && OEN == 0)
      DOUT <= mem[ADR];
  end

endmodule
`endcelldefine
