-- Simple RAM Model
--
-- +-----------------------------+
-- |    Copyright 1997 DOULOS    |
-- |       Library: Memory       |
-- |   designer : John Aynsley   |
-- +-----------------------------+
 
-- Architectures:
--   03.02.97 Behaviour

library IEEE;
use IEEE.std_logic_1164.all;
use vfp.generic_conversions.all;

entity RamChip is
  port (ADR: in Std_logic_vector(3 downto 0);
        Data: inout Std_logic_vector(7 downto 0);
        CS, WE, OE: in Std_logic);
end;

architecture Behaviour of RamChip is
begin
  process(ADR, CS, WE, OE)
    subtype Byte is Std_logic_vector(7 downto 0);
    type Mem is array (0 to 15) of Byte;
    variable Memory: Mem := (others => Byte'(others=>'U'));
  begin
    Data <= (others => 'Z');
    if CS  = '0' then
      if OE = '0' then                  -- Read operation
        Data <= Memory(To_Integer(ADR));
      elsif WE = '0' then               -- Write operation
        Memory(To_Integer(ADR)) := Data;
      end if;
    end if;
  end process;
end;
