// 
// Copyright (C) 2003 Virtual Silicon Technology Inc. All Rights Reserved.
// Silicon Ready, The Heart of Great Silicon, and the Virtual Silicon logo are
// registered trademarks of Virtual Silicon Technology Inc. All other trademarks
// are the property of their respective owner.
// 
// Virtual Silicon Technology Inc.
// 1200 Crossman Ave
// Sunnyvale, CA 94089-1116
// Phone : 408-548-2700
// Fax : 408-548-2750
// Web Site : www.virtual-silicon.com
// 
// VST Library Release: UMCE13H410T3_1.0
// Product: Single Port SRAM Compiler
// Process: L130E HS-FSG
// 
// One-Port RAM 64 words by 32 bits
// column mux = 4
// bytewrite  = n
// test       = n
// powerbus   = a
// frequency  = 100
// 
`timescale 1 ns / 1 ps
`celldefine

module R64X32M4 (
  CK,
  CEN,
  WEN,
  OEN,
  ADR,
  DI,
  DOUT
  );

  parameter words = 131072;
  parameter addMsb = 16;
  parameter bitMsb = 31;

  input CK;
  input CEN;
  input WEN;
  input OEN;
  input [addMsb:0] ADR;
  input [bitMsb:0] DI;
  output [bitMsb:0] DOUT;

  buf (buf_CK, CK);
  buf (buf_CEN, CEN);
  buf (buf_WEN, WEN);
  buf (buf_OEN, OEN);
  wire [addMsb:0] buf_ADR;
  buf (buf_ADR[0], ADR[0]);
  buf (buf_ADR[1], ADR[1]);
  buf (buf_ADR[2], ADR[2]);
  buf (buf_ADR[3], ADR[3]);
  buf (buf_ADR[4], ADR[4]);
  buf (buf_ADR[5], ADR[5]);
  wire [bitMsb:0] buf_DI;
  buf (buf_DI[0], DI[0]);
  buf (buf_DI[1], DI[1]);
  buf (buf_DI[2], DI[2]);
  buf (buf_DI[3], DI[3]);
  buf (buf_DI[4], DI[4]);
  buf (buf_DI[5], DI[5]);
  buf (buf_DI[6], DI[6]);
  buf (buf_DI[7], DI[7]);
  buf (buf_DI[8], DI[8]);
  buf (buf_DI[9], DI[9]);
  buf (buf_DI[10], DI[10]);
  buf (buf_DI[11], DI[11]);
  buf (buf_DI[12], DI[12]);
  buf (buf_DI[13], DI[13]);
  buf (buf_DI[14], DI[14]);
  buf (buf_DI[15], DI[15]);
  buf (buf_DI[16], DI[16]);
  buf (buf_DI[17], DI[17]);
  buf (buf_DI[18], DI[18]);
  buf (buf_DI[19], DI[19]);
  buf (buf_DI[20], DI[20]);
  buf (buf_DI[21], DI[21]);
  buf (buf_DI[22], DI[22]);
  buf (buf_DI[23], DI[23]);
  buf (buf_DI[24], DI[24]);
  buf (buf_DI[25], DI[25]);
  buf (buf_DI[26], DI[26]);
  buf (buf_DI[27], DI[27]);
  buf (buf_DI[28], DI[28]);
  buf (buf_DI[29], DI[29]);
  buf (buf_DI[30], DI[30]);
  buf (buf_DI[31], DI[31]);

  reg int_CEN;
  reg int_WEN;
  reg [addMsb:0] int_ADR;
  reg [bitMsb:0] int_DI;
  reg [bitMsb:0] int_DOUT;
  reg [bitMsb:0] memory_array [63:0];
  reg write_error;
  reg read_error;

  wire [bitMsb:0] out_DOUT;
  assign out_DOUT[0] = int_DOUT[0];
  assign out_DOUT[1] = int_DOUT[1];
  assign out_DOUT[2] = int_DOUT[2];
  assign out_DOUT[3] = int_DOUT[3];
  assign out_DOUT[4] = int_DOUT[4];
  assign out_DOUT[5] = int_DOUT[5];
  assign out_DOUT[6] = int_DOUT[6];
  assign out_DOUT[7] = int_DOUT[7];
  assign out_DOUT[8] = int_DOUT[8];
  assign out_DOUT[9] = int_DOUT[9];
  assign out_DOUT[10] = int_DOUT[10];
  assign out_DOUT[11] = int_DOUT[11];
  assign out_DOUT[12] = int_DOUT[12];
  assign out_DOUT[13] = int_DOUT[13];
  assign out_DOUT[14] = int_DOUT[14];
  assign out_DOUT[15] = int_DOUT[15];
  assign out_DOUT[16] = int_DOUT[16];
  assign out_DOUT[17] = int_DOUT[17];
  assign out_DOUT[18] = int_DOUT[18];
  assign out_DOUT[19] = int_DOUT[19];
  assign out_DOUT[20] = int_DOUT[20];
  assign out_DOUT[21] = int_DOUT[21];
  assign out_DOUT[22] = int_DOUT[22];
  assign out_DOUT[23] = int_DOUT[23];
  assign out_DOUT[24] = int_DOUT[24];
  assign out_DOUT[25] = int_DOUT[25];
  assign out_DOUT[26] = int_DOUT[26];
  assign out_DOUT[27] = int_DOUT[27];
  assign out_DOUT[28] = int_DOUT[28];
  assign out_DOUT[29] = int_DOUT[29];
  assign out_DOUT[30] = int_DOUT[30];
  assign out_DOUT[31] = int_DOUT[31];
  bufif0(DOUT[0], out_DOUT[0], buf_OEN);
  bufif0(DOUT[1], out_DOUT[1], buf_OEN);
  bufif0(DOUT[2], out_DOUT[2], buf_OEN);
  bufif0(DOUT[3], out_DOUT[3], buf_OEN);
  bufif0(DOUT[4], out_DOUT[4], buf_OEN);
  bufif0(DOUT[5], out_DOUT[5], buf_OEN);
  bufif0(DOUT[6], out_DOUT[6], buf_OEN);
  bufif0(DOUT[7], out_DOUT[7], buf_OEN);
  bufif0(DOUT[8], out_DOUT[8], buf_OEN);
  bufif0(DOUT[9], out_DOUT[9], buf_OEN);
  bufif0(DOUT[10], out_DOUT[10], buf_OEN);
  bufif0(DOUT[11], out_DOUT[11], buf_OEN);
  bufif0(DOUT[12], out_DOUT[12], buf_OEN);
  bufif0(DOUT[13], out_DOUT[13], buf_OEN);
  bufif0(DOUT[14], out_DOUT[14], buf_OEN);
  bufif0(DOUT[15], out_DOUT[15], buf_OEN);
  bufif0(DOUT[16], out_DOUT[16], buf_OEN);
  bufif0(DOUT[17], out_DOUT[17], buf_OEN);
  bufif0(DOUT[18], out_DOUT[18], buf_OEN);
  bufif0(DOUT[19], out_DOUT[19], buf_OEN);
  bufif0(DOUT[20], out_DOUT[20], buf_OEN);
  bufif0(DOUT[21], out_DOUT[21], buf_OEN);
  bufif0(DOUT[22], out_DOUT[22], buf_OEN);
  bufif0(DOUT[23], out_DOUT[23], buf_OEN);
  bufif0(DOUT[24], out_DOUT[24], buf_OEN);
  bufif0(DOUT[25], out_DOUT[25], buf_OEN);
  bufif0(DOUT[26], out_DOUT[26], buf_OEN);
  bufif0(DOUT[27], out_DOUT[27], buf_OEN);
  bufif0(DOUT[28], out_DOUT[28], buf_OEN);
  bufif0(DOUT[29], out_DOUT[29], buf_OEN);
  bufif0(DOUT[30], out_DOUT[30], buf_OEN);
  bufif0(DOUT[31], out_DOUT[31], buf_OEN);

  or (CENorWEN, buf_CEN, buf_WEN);

  reg shADR_notifier;
  reg shDI_notifier;
  reg shCEN_notifier;
  reg shWEN_notifier;
  reg mpwCK_notifier;

  integer i;

  parameter x_data = 32'bx;
  parameter x_adr  = 6'bx;

  initial begin
    read_error = 1'b0;
    write_error = 1'b0;

      // Wait for valid initial transition
    wait (buf_CK === 1'b0);

    forever @(posedge buf_CK) begin

        // 0->1 transition
      if (buf_CK === 1'b1) begin

        int_CEN = buf_CEN;
        if (buf_CEN === 1'b0) begin
          int_WEN = buf_WEN;
          int_ADR = buf_ADR;
          int_DI = buf_DI;
         end

        if (int_CEN === 1'b0) begin
            // Read cycle
          if (int_WEN === 1'b1) begin
            if (^int_ADR === 1'bx)  begin
              int_DOUT = x_data;
            end else if (read_error === 1'b0) begin
              int_DOUT = memory_array[int_ADR];
            end
            // Write cycle
          end else if (int_WEN === 1'b0) begin
            if (^int_ADR === 1'bx) begin
              x_memory;
            end else if (write_error === 1'b0) begin
              memory_array[int_ADR] = int_DI; // Write cycle
              int_DOUT = int_DI;
            end
            // Unknown cycle
          end else begin
            x_memory;
          end
        end else if (int_CEN !== 1'b1) begin
          if (int_WEN === 1'b1) begin
            int_DOUT = x_data;
          end else begin
            x_memory;
          end
        end
        // 0->unknown transition, wait until returns to 0
      end else begin
        int_CEN = 1'bx;
        int_WEN = 1'bx;
        int_ADR = x_adr;
        int_DI = x_data;
        x_memory;
        wait (buf_CK === 1'b0);
      end

    end
  end  // end memory loop

task x_memory;
  begin
    write_error = 1'b1;
    int_DOUT = x_data;
    if (^int_ADR === 1'bx) begin
      for (i = 0; i < words; i=i+1) begin
        memory_array[i] = x_data;
      end
    end else begin
      memory_array[int_ADR] = x_data;
    end
    wait (buf_CK === 1'b0);
    write_error = 1'b0;
  end
endtask

task writeSH_error;
  begin
    x_memory;
  end
endtask

task readSH_error;
  begin
    read_error = 1'b1;
    int_DOUT = x_data;
      // Need to make sure int_WEN doesn't go unknown
    wait ((buf_CK === 1'b0) || (int_WEN === 1'bx));
    if (int_WEN === 1'bx) begin
      writeSH_error;
    end
    read_error = 1'b0;
  end
endtask

task SH_error;
  begin
    if (int_WEN === 1'b1) begin
      readSH_error;
    end
    else begin
      writeSH_error;
    end
  end
endtask

always @(shADR_notifier) begin
  int_ADR = x_adr;
  $display ("%m: Address timing violation detected %t", $time);
  x_memory;
end

always @(shDI_notifier) begin
  int_DI = x_data;
  $display ("%m:  Input data timing violation detected %t", $time);
  writeSH_error;
end

always @(shCEN_notifier) begin
  int_CEN = 1'bx;
  $display ("%m:  Chip enable timing violation detected %t", $time);
  SH_error;
end

always @(shWEN_notifier) begin
  int_WEN = 1'bx;
  $display ("%m:  Write enable timing violation detected %t", $time);
  writeSH_error;
end

always @(mpwCK_notifier) begin
  $display ("%m:  CLK cycle timing violation detected %t", $time);
  SH_error;
end

specify

    // Path delays
 if (WEN) (CK *> DOUT[0]) = (1,1);
 if (!WEN) (CK *> DOUT[0]) = (1,1);
 ifnone (CK *> DOUT[0]) = (1,1);
 if (WEN) (CK *> DOUT[1]) = (1,1);
 if (!WEN) (CK *> DOUT[1]) = (1,1);
 ifnone (CK *> DOUT[1]) = (1,1);
 if (WEN) (CK *> DOUT[2]) = (1,1);
 if (!WEN) (CK *> DOUT[2]) = (1,1);
 ifnone (CK *> DOUT[2]) = (1,1);
 if (WEN) (CK *> DOUT[3]) = (1,1);
 if (!WEN) (CK *> DOUT[3]) = (1,1);
 ifnone (CK *> DOUT[3]) = (1,1);
 if (WEN) (CK *> DOUT[4]) = (1,1);
 if (!WEN) (CK *> DOUT[4]) = (1,1);
 ifnone (CK *> DOUT[4]) = (1,1);
 if (WEN) (CK *> DOUT[5]) = (1,1);
 if (!WEN) (CK *> DOUT[5]) = (1,1);
 ifnone (CK *> DOUT[5]) = (1,1);
 if (WEN) (CK *> DOUT[6]) = (1,1);
 if (!WEN) (CK *> DOUT[6]) = (1,1);
 ifnone (CK *> DOUT[6]) = (1,1);
 if (WEN) (CK *> DOUT[7]) = (1,1);
 if (!WEN) (CK *> DOUT[7]) = (1,1);
 ifnone (CK *> DOUT[7]) = (1,1);
 if (WEN) (CK *> DOUT[8]) = (1,1);
 if (!WEN) (CK *> DOUT[8]) = (1,1);
 ifnone (CK *> DOUT[8]) = (1,1);
 if (WEN) (CK *> DOUT[9]) = (1,1);
 if (!WEN) (CK *> DOUT[9]) = (1,1);
 ifnone (CK *> DOUT[9]) = (1,1);
 if (WEN) (CK *> DOUT[10]) = (1,1);
 if (!WEN) (CK *> DOUT[10]) = (1,1);
 ifnone (CK *> DOUT[10]) = (1,1);
 if (WEN) (CK *> DOUT[11]) = (1,1);
 if (!WEN) (CK *> DOUT[11]) = (1,1);
 ifnone (CK *> DOUT[11]) = (1,1);
 if (WEN) (CK *> DOUT[12]) = (1,1);
 if (!WEN) (CK *> DOUT[12]) = (1,1);
 ifnone (CK *> DOUT[12]) = (1,1);
 if (WEN) (CK *> DOUT[13]) = (1,1);
 if (!WEN) (CK *> DOUT[13]) = (1,1);
 ifnone (CK *> DOUT[13]) = (1,1);
 if (WEN) (CK *> DOUT[14]) = (1,1);
 if (!WEN) (CK *> DOUT[14]) = (1,1);
 ifnone (CK *> DOUT[14]) = (1,1);
 if (WEN) (CK *> DOUT[15]) = (1,1);
 if (!WEN) (CK *> DOUT[15]) = (1,1);
 ifnone (CK *> DOUT[15]) = (1,1);
 if (WEN) (CK *> DOUT[16]) = (1,1);
 if (!WEN) (CK *> DOUT[16]) = (1,1);
 ifnone (CK *> DOUT[16]) = (1,1);
 if (WEN) (CK *> DOUT[17]) = (1,1);
 if (!WEN) (CK *> DOUT[17]) = (1,1);
 ifnone (CK *> DOUT[17]) = (1,1);
 if (WEN) (CK *> DOUT[18]) = (1,1);
 if (!WEN) (CK *> DOUT[18]) = (1,1);
 ifnone (CK *> DOUT[18]) = (1,1);
 if (WEN) (CK *> DOUT[19]) = (1,1);
 if (!WEN) (CK *> DOUT[19]) = (1,1);
 ifnone (CK *> DOUT[19]) = (1,1);
 if (WEN) (CK *> DOUT[20]) = (1,1);
 if (!WEN) (CK *> DOUT[20]) = (1,1);
 ifnone (CK *> DOUT[20]) = (1,1);
 if (WEN) (CK *> DOUT[21]) = (1,1);
 if (!WEN) (CK *> DOUT[21]) = (1,1);
 ifnone (CK *> DOUT[21]) = (1,1);
 if (WEN) (CK *> DOUT[22]) = (1,1);
 if (!WEN) (CK *> DOUT[22]) = (1,1);
 ifnone (CK *> DOUT[22]) = (1,1);
 if (WEN) (CK *> DOUT[23]) = (1,1);
 if (!WEN) (CK *> DOUT[23]) = (1,1);
 ifnone (CK *> DOUT[23]) = (1,1);
 if (WEN) (CK *> DOUT[24]) = (1,1);
 if (!WEN) (CK *> DOUT[24]) = (1,1);
 ifnone (CK *> DOUT[24]) = (1,1);
 if (WEN) (CK *> DOUT[25]) = (1,1);
 if (!WEN) (CK *> DOUT[25]) = (1,1);
 ifnone (CK *> DOUT[25]) = (1,1);
 if (WEN) (CK *> DOUT[26]) = (1,1);
 if (!WEN) (CK *> DOUT[26]) = (1,1);
 ifnone (CK *> DOUT[26]) = (1,1);
 if (WEN) (CK *> DOUT[27]) = (1,1);
 if (!WEN) (CK *> DOUT[27]) = (1,1);
 ifnone (CK *> DOUT[27]) = (1,1);
 if (WEN) (CK *> DOUT[28]) = (1,1);
 if (!WEN) (CK *> DOUT[28]) = (1,1);
 ifnone (CK *> DOUT[28]) = (1,1);
 if (WEN) (CK *> DOUT[29]) = (1,1);
 if (!WEN) (CK *> DOUT[29]) = (1,1);
 ifnone (CK *> DOUT[29]) = (1,1);
 if (WEN) (CK *> DOUT[30]) = (1,1);
 if (!WEN) (CK *> DOUT[30]) = (1,1);
 ifnone (CK *> DOUT[30]) = (1,1);
 if (WEN) (CK *> DOUT[31]) = (1,1);
 if (!WEN) (CK *> DOUT[31]) = (1,1);
 ifnone (CK *> DOUT[31]) = (1,1);
 (OEN *> DOUT[0]) = 0; 
 (OEN *> DOUT[1]) = 0; 
 (OEN *> DOUT[2]) = 0; 
 (OEN *> DOUT[3]) = 0; 
 (OEN *> DOUT[4]) = 0; 
 (OEN *> DOUT[5]) = 0; 
 (OEN *> DOUT[6]) = 0; 
 (OEN *> DOUT[7]) = 0; 
 (OEN *> DOUT[8]) = 0; 
 (OEN *> DOUT[9]) = 0; 
 (OEN *> DOUT[10]) = 0; 
 (OEN *> DOUT[11]) = 0; 
 (OEN *> DOUT[12]) = 0; 
 (OEN *> DOUT[13]) = 0; 
 (OEN *> DOUT[14]) = 0; 
 (OEN *> DOUT[15]) = 0; 
 (OEN *> DOUT[16]) = 0; 
 (OEN *> DOUT[17]) = 0; 
 (OEN *> DOUT[18]) = 0; 
 (OEN *> DOUT[19]) = 0; 
 (OEN *> DOUT[20]) = 0; 
 (OEN *> DOUT[21]) = 0; 
 (OEN *> DOUT[22]) = 0; 
 (OEN *> DOUT[23]) = 0; 
 (OEN *> DOUT[24]) = 0; 
 (OEN *> DOUT[25]) = 0; 
 (OEN *> DOUT[26]) = 0; 
 (OEN *> DOUT[27]) = 0; 
 (OEN *> DOUT[28]) = 0; 
 (OEN *> DOUT[29]) = 0; 
 (OEN *> DOUT[30]) = 0; 
 (OEN *> DOUT[31]) = 0; 

`ifdef no_tchk
  `else 
    // Timing check parameters
  specparam tsadrl = 0;
  specparam thadrl = 0;
  specparam tsadrh = 0;
  specparam thadrh = 0;
  specparam tsdil = 0;
  specparam tsdih = 0;
  specparam thdil = 0;
  specparam thdih = 0;
  specparam tscenl = 0;
  specparam thcenl = 0;
  specparam tscenh = 0;
  specparam thcenh = 0;
  specparam tswenl = 0;
  specparam thwenl = 0;
  specparam tswenh = 0;
  specparam thwenh = 0;
  specparam tcyc = 0;
  specparam tlck = 0;
  specparam thck = 0;

    // Timing checks
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[0], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[0], tsadrh, thadrh, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[1], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[1], tsadrh, thadrh, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[2], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[2], tsadrh, thadrh, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[3], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[3], tsadrh, thadrh, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[4], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[4], tsadrh, thadrh, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), negedge ADR[5], tsadrl, thadrl, shADR_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge ADR[5], tsadrh, thadrh, shADR_notifier);

  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[0], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[0], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[1], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[1], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[2], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[2], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[3], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[3], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[4], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[4], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[5], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[5], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[6], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[6], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[7], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[7], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[8], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[8], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[9], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[9], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[10], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[10], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[11], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[11], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[12], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[12], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[13], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[13], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[14], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[14], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[15], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[15], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[16], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[16], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[17], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[17], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[18], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[18], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[19], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[19], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[20], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[20], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[21], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[21], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[22], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[22], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[23], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[23], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[24], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[24], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[25], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[25], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[26], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[26], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[27], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[27], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[28], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[28], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[29], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[29], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[30], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[30], tsdih, thdih, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), negedge DI[31], tsdil, thdil, shDI_notifier);
  $setuphold(posedge CK &&& (CENorWEN===1'b0), posedge DI[31], tsdih, thdih, shDI_notifier);

  $setuphold(posedge CK, negedge CEN, tscenl, thcenl, shCEN_notifier);
  $setuphold(posedge CK, posedge CEN, tscenh, thcenh, shCEN_notifier);

  $setuphold(posedge CK &&& (CEN===1'b0), negedge WEN, tswenl, thwenl, shWEN_notifier);
  $setuphold(posedge CK &&& (CEN===1'b0), posedge WEN, tswenh, thwenh, shWEN_notifier);

  $period(posedge CK, tcyc, mpwCK_notifier);
  $period(negedge CK, tcyc, mpwCK_notifier);
  $width(negedge CK, tlck, 0, mpwCK_notifier);
  $width(posedge CK, thck, 0, mpwCK_notifier);
`endif

endspecify

endmodule
`endcelldefine
