//data Memory 

module read_write_memory (wr, rd, add, rd_data, wr_data);

input wr, rd;
input [31 : 0] add, wr_data;
output [31 : 0] rd_data;

reg [31 : 0] rd_data;
reg [31 : 0] page_mem [1023 : 0];
reg [31 : 0] start_mem, end_mem;
reg change ;

initial begin
     change <= 0;
     start_mem <= 22'd0;
     end_mem <= 22'd1023;
     $readmemb("mem_data_file1.v",page_mem);
end

always @ (rd or add )
 if (rd && (add[31:10] < end_mem) && (add[31:10] >= start_mem))
     rd_data = page_mem[add[9 : 0]];
 else if (rd)
   begin
    if (change == 1)
      case (start_mem)
	   22'd0 : $writememb("mem_file1.v",page_mem);
	   22'd1 : $writememb("mem_file2.v",page_mem);
	   22'd2 : $writememb("mem_file3.v",page_mem);
	   default : $writememb("mem_file4.v",page_mem);
      endcase

      case (add [31 : 10])
	   22'd0 : $readmemb("mem_file1.v",page_mem);
	   22'd1 : $readmemb("mem_file2.v",page_mem);
	   22'd2 : $readmemb("mem_file3.v",page_mem);
	   default : $readmemb("mem_file4.v",page_mem);
      endcase
      start_mem = add [31 : 10];
      rd_data = page_mem[add[9 : 0]];
       end_mem = start_mem+ 22'd1;
      change = 0;
 end

always @ (wr or add or wr_data)
 if (wr && (add[31:10] < end_mem) && (add[31:10] >=  start_mem)) begin
      page_mem[add[9 : 0]] = wr_data;
      change = 1; 
 end else if (wr) begin
    if (change == 1)
      case (start_mem)
	   22'd0 : $writememb("mem_data_file1.v",page_mem);
	   22'd1 : $writememb("mem_data_file2.v",page_mem);
	   22'd2 : $writememb("mem_data_file3.v",page_mem);
	   default : $writememb("mem_data_file4.v",page_mem);
      endcase

      case (add [31 : 10])
	   22'd0 : $readmemb("mem_data_file1.v",page_mem);
	   22'd1 : $readmemb("mem_data_file2.v",page_mem);
	   22'd2 : $readmemb("mem_data_file3.v",page_mem);
	   default : $readmemb("mem_data_file4.v",page_mem);
      endcase
      page_mem[add[9 : 0]] = wr_data;
      start_mem = add [31 : 10];
       end_mem = start_mem+ 22'd1;
      change = 1; 
 end
endmodule
//-------------------------------------------------------

// instruction Memory 

module read_only_memory (rd_add, rd_data);

input [31 : 0] rd_add; 
output [31 : 0] rd_data;
//reg [31 :0 ] rd_data;

reg [31 : 0] page_mem [1023 : 0];
reg [31 : 0] start_mem, end_mem;

initial begin
     start_mem <= 32'd0;
     end_mem <= 32'd1023;
     $readmemb("mem_ins_file1.v",page_mem);
end

always @ (rd_add )
 if (~((rd_add[31:10] < end_mem) && (rd_add[31:10] >= start_mem)))
  begin
      case (rd_add [31 : 10])
	   22'd0 : $readmemb("mem_ins_file1.v",page_mem);
	   22'd1 : $readmemb("mem_ins_file2.v",page_mem);
	   22'd2 : $readmemb("mem_ins_file3.v",page_mem);
	   default : $readmemb("mem_ins_file4.v",page_mem);
      endcase
      start_mem = rd_add [31 : 10];
       end_mem = start_mem+ 32'd1;
   end
 assign  rd_data = page_mem[rd_add[11 : 2]];
endmodule










